package dbnotification;

import java.sql.ResultSet;
import java.sql.SQLException;

import java.util.Properties;

import javax.naming.InitialContext;
import javax.naming.NamingException;

import javax.sql.DataSource;

import oracle.jdbc.OracleConnection;
import oracle.jdbc.OracleStatement;
import oracle.jdbc.dcn.DatabaseChangeRegistration;

public class DBChangeNotification {
    public DBChangeNotification() {
        super();
    }


    public void subscribeForDBChanges() throws SQLException, Exception {

        OracleConnection conn = connectDB();
        Properties prop = new Properties();
        prop.setProperty(OracleConnection.DCN_NOTIFY_ROWIDS, "true");
        prop.setProperty(OracleConnection.DCN_QUERY_CHANGE_NOTIFICATION, "true");
        DatabaseChangeRegistration dcr = conn.registerDatabaseChangeNotification(prop);

        DBChangeNotificationListener listener = new DBChangeNotificationListener(this);
        dcr.addListener(listener);

        OracleStatement stmt = (OracleStatement) conn.createStatement();
        stmt.setDatabaseChangeRegistration(dcr);

        ResultSet rs = stmt.executeQuery("select salary from employees where employee_id=100");

        rs.close();
        stmt.close();
        conn.close();
    }


    private OracleConnection connectDB() {

        OracleConnection conn = null;
        try {
            conn = (OracleConnection) ((DataSource) (new InitialContext()).lookup("jdbc/HrDataSource")).getConnection();
            System.out.println("******* DBChange controller: Connected to DB");
        } catch (NamingException e) {
            System.out.println("******** Datasource 'jdbc/HrDataSource' was not found");
        } catch (SQLException e) {
            System.out.println("********Unexpected error: " + e);
        }
        return conn;
    }


}
